/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: AEB.c
 *
 * Code generated for Simulink model 'AEB'.
 *
 * Model version                  : 1.1
 * Simulink Coder version         : 9.4 (R2020b) 29-Jul-2020
 * C/C++ source code generated on : Wed May 19 16:58:50 2021
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Intel->x86-64 (Windows64)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "AEB.h"
#include "AEB_private.h"

/* Named constants for Chart: '<S1>/AEB_Logic' */
#define AEB_IN_Default                 ((uint8_T)1U)
#define AEB_IN_FCW                     ((uint8_T)2U)
#define AEB_IN_Full_Braking            ((uint8_T)3U)
#define AEB_IN_Partial_Braking1        ((uint8_T)4U)
#define AEB_IN_Partial_Braking2        ((uint8_T)5U)

/* Block states (default storage) */
DW_AEB_T AEB_DW;

/* External inputs (root inport signals with default storage) */
ExtU_AEB_T AEB_U;

/* External outputs (root outports fed by signals with default storage) */
ExtY_AEB_T AEB_Y;

/* Real-time model */
static RT_MODEL_AEB_T AEB_M_;
RT_MODEL_AEB_T *const AEB_M = &AEB_M_;

/* Model step function  - Periodic Runnable */
FUNC(void, RTE_APPL_CODE) AEB_step(void)
{
  real_T rtb_Divide11;
  real_T rtb_Sum1;
  real_T tmp;

  /* Outport: '<Root>/collision' incorporates:
   *  Constant: '<S4>/const1'
   *  Constant: '<S4>/const2'
   *  Inport: '<Root>/mioDistance'
   *  RelationalOperator: '<S4>/Relational Operator'
   *  Sum: '<S4>/Sum'
   */

  
  AEB_Y.collision = (Rte_DRead_RelativeDistance_RelativeDistance() - 3.7 < 0.1);
  Rte_Write_Collision_Collision(AEB_Y.collision);

  /* Abs: '<S4>/Abs' incorporates:
   *  Inport: '<Root>/mioVelocity'
   */
  AEB_U.relative_velocity = Rte_DRead_RelativeSpeed_RelativeSpeed();
  rtb_Divide11 = fabs(AEB_U.relative_velocity);

  /* Saturate: '<S4>/Saturation' */
  if (rtb_Divide11 > 100.0) {
    rtb_Divide11 = 100.0;
  } else {
    if (rtb_Divide11 < 0.01) {
      rtb_Divide11 = 0.01;
    }
  }

  /* End of Saturate: '<S4>/Saturation' */

  /* Signum: '<S4>/Sign' incorporates:
   *  Inport: '<Root>/mioVelocity'
   */
  AEB_U.relative_velocity = Rte_DRead_RelativeSpeed_RelativeSpeed();
  if (AEB_U.relative_velocity < 0.0) {
    tmp = -1.0;
  } else if (AEB_U.relative_velocity > 0.0) {
    tmp = 1.0;
  } else {
    tmp = AEB_U.relative_velocity;
  }

  /* End of Signum: '<S4>/Sign' */

  /* Product: '<S4>/Divide11' incorporates:
   *  Constant: '<S4>/const1'
   *  Inport: '<Root>/mioDistance'
   *  Product: '<S4>/Divide3'
   *  Sum: '<S4>/Sum'
   */
  
  rtb_Divide11 = (Rte_DRead_RelativeDistance_RelativeDistance() - 3.7) / rtb_Divide11 * tmp;

  /* RelationalOperator: '<S1>/Relational Operator1' incorporates:
   *  Constant: '<S1>/const3'
   *  Inport: '<Root>/egoVelocity'
   */
  AEB_U.egoVelocity = Rte_DRead_VehicleSpeed_VehicleSpeed();
  AEB_Y.EgoCarStop = (AEB_U.egoVelocity <= 0.1);
  Rte_Write_EgoStop_EgoStop(AEB_Y.EgoCarStop);

  /* Sum: '<S3>/Sum1' incorporates:
   *  Constant: '<S3>/const3'
   *  Constant: '<S3>/const6'
   *  Inport: '<Root>/egoVelocity'
   *  Product: '<S3>/Divide12'
   */
  rtb_Sum1 = AEB_U.egoVelocity / 4.0 + 1.2;

  /* Chart: '<S1>/AEB_Logic' incorporates:
   *  Constant: '<S1>/const4'
   *  Constant: '<S1>/const5'
   *  Constant: '<S1>/const6'
   *  Inport: '<Root>/egoVelocity'
   *  Product: '<S3>/Divide1'
   *  Product: '<S3>/Divide3'
   *  Product: '<S3>/Divide5'
   */
  if (AEB_DW.is_active_c5_AEB == 0U) {
    AEB_DW.is_active_c5_AEB = 1U;
    AEB_DW.is_c5_AEB = AEB_IN_Default;

    /* Outport: '<Root>/AEBstatus' */
    AEB_Y.AEBstatus = 0U;
    Rte_Write_Status_Status(AEB_Y.AEBstatus);

    /* Outport: '<Root>/FCWactivate' */
    AEB_Y.FCWactivate = 0U;
    
    /* Outport: '<Root>/decel' */
    AEB_Y.decel = 0.0;
    Rte_Write_Brake_Brake(AEB_Y.decel);
  } else {
    switch (AEB_DW.is_c5_AEB) {
     case AEB_IN_Default:
      /* Outport: '<Root>/AEBstatus' */
      AEB_Y.AEBstatus = 0U;

      /* Outport: '<Root>/FCWactivate' */
      AEB_Y.FCWactivate = 0U;
      if ((fabs(rtb_Divide11) < rtb_Sum1) && (rtb_Divide11 < 0.0)) {
        AEB_DW.is_c5_AEB = AEB_IN_FCW;

        /* Outport: '<Root>/AEBstatus' */
        AEB_Y.AEBstatus = 0U;

        /* Outport: '<Root>/FCWactivate' */
        AEB_Y.FCWactivate = 1U;

        /* Outport: '<Root>/decel' */
        AEB_Y.decel = 0.0;
      }
      break;

     case AEB_IN_FCW:
      /* Outport: '<Root>/AEBstatus' */
      AEB_Y.AEBstatus = 0U;

      /* Outport: '<Root>/FCWactivate' */
      AEB_Y.FCWactivate = 1U;
      tmp = fabs(rtb_Divide11);
      if ((tmp < AEB_U.egoVelocity / 3.8) && (rtb_Divide11 < 0.0)) {
        AEB_DW.is_c5_AEB = AEB_IN_Partial_Braking1;

        /* Outport: '<Root>/AEBstatus' */
        AEB_Y.AEBstatus = 1U;

        /* Outport: '<Root>/FCWactivate' */
        AEB_Y.FCWactivate = 1U;

        /* Outport: '<Root>/decel' */
        AEB_Y.decel = 3.8;
      } else {
        if (tmp >= 1.2 * rtb_Sum1) {
          AEB_DW.is_c5_AEB = AEB_IN_Default;

          /* Outport: '<Root>/AEBstatus' */
          AEB_Y.AEBstatus = 0U;

          /* Outport: '<Root>/FCWactivate' */
          AEB_Y.FCWactivate = 0U;

          /* Outport: '<Root>/decel' */
          AEB_Y.decel = 0.0;
        }
      }
      break;

     case AEB_IN_Full_Braking:
      /* Outport: '<Root>/AEBstatus' */
      AEB_Y.AEBstatus = 3U;

      /* Outport: '<Root>/FCWactivate' */
      AEB_Y.FCWactivate = 1U;
      if (AEB_Y.EgoCarStop) {
        AEB_DW.is_c5_AEB = AEB_IN_Default;

        /* Outport: '<Root>/AEBstatus' */
        AEB_Y.AEBstatus = 0U;

        /* Outport: '<Root>/FCWactivate' */
        AEB_Y.FCWactivate = 0U;

        /* Outport: '<Root>/decel' */
        AEB_Y.decel = 0.0;
      }
      break;

     case AEB_IN_Partial_Braking1:
      /* Outport: '<Root>/AEBstatus' */
      AEB_Y.AEBstatus = 1U;

      /* Outport: '<Root>/FCWactivate' */
      AEB_Y.FCWactivate = 1U;
      if ((fabs(rtb_Divide11) < AEB_U.egoVelocity / 5.3) && (rtb_Divide11 < 0.0))
      {
        AEB_DW.is_c5_AEB = AEB_IN_Partial_Braking2;

        /* Outport: '<Root>/AEBstatus' */
        AEB_Y.AEBstatus = 2U;

        /* Outport: '<Root>/FCWactivate' */
        AEB_Y.FCWactivate = 1U;

        /* Outport: '<Root>/decel' */
        AEB_Y.decel = 5.3;
      } else {
        if (AEB_Y.EgoCarStop) {
          AEB_DW.is_c5_AEB = AEB_IN_Default;

          /* Outport: '<Root>/AEBstatus' */
          AEB_Y.AEBstatus = 0U;

          /* Outport: '<Root>/FCWactivate' */
          AEB_Y.FCWactivate = 0U;

          /* Outport: '<Root>/decel' */
          AEB_Y.decel = 0.0;
        }
      }
      break;

     default:
      /* Outport: '<Root>/AEBstatus' */
      /* case IN_Partial_Braking2: */
      AEB_Y.AEBstatus = 2U;

      /* Outport: '<Root>/FCWactivate' */
      AEB_Y.FCWactivate = 1U;
      if ((fabs(rtb_Divide11) < AEB_U.egoVelocity / 9.8) && (rtb_Divide11 < 0.0))
      {
        AEB_DW.is_c5_AEB = AEB_IN_Full_Braking;

        /* Outport: '<Root>/AEBstatus' */
        AEB_Y.AEBstatus = 3U;

        /* Outport: '<Root>/FCWactivate' */
        AEB_Y.FCWactivate = 1U;

        /* Outport: '<Root>/decel' */
        AEB_Y.decel = 9.8;
      } else {
        if (AEB_Y.EgoCarStop) {
          AEB_DW.is_c5_AEB = AEB_IN_Default;

          /* Outport: '<Root>/AEBstatus' */
          AEB_Y.AEBstatus = 0U;

          /* Outport: '<Root>/FCWactivate' */
          AEB_Y.FCWactivate = 0U;

          /* Outport: '<Root>/decel' */
          AEB_Y.decel = 0.0;
        }
      }
      break;
    }
  }

  Rte_Write_Status_Status(AEB_Y.AEBstatus);
  Rte_Write_Brake_Brake(AEB_Y.decel);

  /* End of Chart: '<S1>/AEB_Logic' */
}

/* Model initialize function */
FUNC(void, RTE_APPL_CODE) AEB_initialize(void)
{
  /* (no initialization code required) */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
