/********************************************************************************************************************
* Copyright (c) Huawei Technologies France SASU  All rights reserved.
* Last Update : 2021-05-26
********************************************************************************************************************/
#if (!defined(AUTOMATIC))
#define AUTOMATIC
#endif /* !AUTOMATIC */

#if (!defined(TYPEDEF))
#define TYPEDEF
#endif /* !TYPEDEF */

#if (!defined(RTE_CODE))
#define RTE_CODE                     TYPEDEF
#endif /* RTE_CODE */

#if (!defined(RTE_DATA))
#define RTE_DATA                     TYPEDEF
#endif /* RTE_DATA */

#if (!defined(RTE_APPL_DATA))
#define RTE_APPL_DATA                TYPEDEF
#endif /* RTE_APPL_DATA */

#if (!defined(RTE_APPL_CODE))
#define RTE_APPL_CODE                TYPEDEF
#endif /* RTE_APPL_CODE */

#if (!defined(RTE_CONST))
#define RTE_CONST                    TYPEDEF
#endif /* RTE_CONST */

#if (!defined(RTE_APPL_CONST))
#define RTE_APPL_CONST               TYPEDEF
#endif /* RTE_APPL_CONST */

#if (!defined(VAR))
#define VAR(vartype, memclass) vartype memclass
#endif /* !VAR */

#if (!defined(CONST))
#define CONST(consttype, memclass) consttype const memclass
#endif /* !CONST */

#if (!defined(P2VAR))
# define P2VAR(ptrtype, memclass, ptrclass) ptrtype memclass * ptrclass
#endif /* !P2VAR */

#if (!defined(P2CONST))
#define P2CONST(ptrtype, memclass, ptrclass) ptrtype const memclass * ptrclass
#endif /* !P2CONST */

#if (!defined(CONSTP2VAR))
#define CONSTP2VAR(ptrtype, memclass, ptrclass)\
  ptrtype memclass * const ptrclass
#endif /* !CONSTP2VAR */

#if (!defined(CONSTP2CONST))
#define CONSTP2CONST(ptrtype, memclass, ptrclass)\
  ptrtype const memclass *  const ptrclass
#endif /* !CONSTP2CONST */

#if (!defined(P2FUNC))
#define P2FUNC(rettype, ptrclass, fctname) rettype (* ptrclass fctname)
#endif /* !P2FUNC */

#if (!defined(FUNC))
#define FUNC(rettype, memclass) rettype memclass
#endif /* !FUNC */

#if (!defined(FUNC_P2VAR))
#define FUNC_P2VAR(rettype, ptrclass, memclass) rettype * ptrclass memclass
#endif /* !FUNC_P2VAR */

#if (!defined(FUNC_P2CONST))
#define FUNC_P2CONST(rettype, ptrclass, memclass) \
  rettype const * ptrclass memclass
#endif /* !FUNC_P2CONST */

/* Standard Types and Platform Types */


/**********************************************************************************************************************
*  GLOBAL CONSTANT MACROS
*********************************************************************************************************************/

/* ##V_CFG_MANAGEMENT ##CQProject : CommonAsr_Vtt CQComponent : Impl_PlatformTypes */
#define COMMONASR_VTT_IMPL_PLATFORMTYPES_VERSION         0x0200
#define COMMONASR_VTT_IMPL_PLATFORMTYPES_RELEASE_VERSION 0x00

#define PLATFORM_VENDOR_ID    30u    /* SREQ00015439, SREQ00015413 */
#define PLATFORM_MODULE_ID    199u   /* SREQ00015439, SREQ00015413 */


/* AUTOSAR Software Specification Document Version Information */

/* AUTOSAR release 4.0 R3 */
#   define PLATFORM_AR_RELEASE_MAJOR_VERSION      (4u)
#   define PLATFORM_AR_RELEASE_MINOR_VERSION      (0u)
#   define PLATFORM_AR_RELEASE_REVISION_VERSION   (3u)

/* Component Version Information */
#define PLATFORM_SW_MAJOR_VERSION       (2u)
#define PLATFORM_SW_MINOR_VERSION       (0u)
#define PLATFORM_SW_PATCH_VERSION       (0u)


#define CPU_TYPE_8       8
#define CPU_TYPE_16      16
#define CPU_TYPE_32      32

#define MSB_FIRST        0    /* big endian bit ordering */
#define LSB_FIRST        1    /* little endian bit ordering */

#define HIGH_BYTE_FIRST  0    /* big endian byte ordering */
#define LOW_BYTE_FIRST   1    /* little endian byte ordering */

#ifndef TRUE
#define TRUE   1
#endif

#ifndef FALSE
#define FALSE  0
#endif

#define CPU_TYPE         CPU_TYPE_32

#define CPU_BIT_ORDER    LSB_FIRST        /*little endian bit ordering*/

#define CPU_BYTE_ORDER   LOW_BYTE_FIRST   /*little endian byte ordering*/



/**********************************************************************************************************************
*  GLOBAL DATA TYPES AND STRUCTURES
*********************************************************************************************************************/
#define Rte_TypeDef_boolean
typedef unsigned char         boolean;       /*        TRUE .. FALSE           */

#define Rte_TypeDef_sint8
typedef signed char           sint8;         /*        -127 .. +127            */

#define Rte_TypeDef_uint8
typedef unsigned char         uint8;         /*           0 .. 255             */

#define Rte_TypeDef_sint16
typedef signed short          sint16;        /*      -32767 .. +32767          */

#define Rte_TypeDef_uint16
typedef unsigned short        uint16;        /*           0 .. 65535           */

#define Rte_TypeDef_sint32
typedef signed long           sint32;        /* -2147483647 .. +2147483647     */

#define Rte_TypeDef_uint32
typedef unsigned long         uint32;        /*           0 .. 4294967295      */

#define Rte_TypeDef_sint8_least
typedef signed char           sint8_least;   /* At least 7 bit + 1 bit sign    */

#define Rte_TypeDef_uint8_least
typedef unsigned char         uint8_least;   /* At least 8 bit                 */

#define Rte_TypeDef_sint16_least
typedef signed short          sint16_least;  /* At least 15 bit + 1 bit sign   */

#define Rte_TypeDef_uint16_least
typedef unsigned short        uint16_least;  /* At least 16 bit                */

#define Rte_TypeDef_sint32_least
typedef signed long           sint32_least;  /* At least 31 bit + 1 bit sign   */

#define Rte_TypeDef_uint32_least
typedef unsigned long         uint32_least;  /* At least 32 bit                */

#define Rte_TypeDef_float32
typedef float                 float32;

#define Rte_TypeDef_float64
typedef double                float64;


#define PLATFORM_SUPPORT_SINT64_UINT64

#define Rte_TypeDef_sint64
typedef signed long long      sint64;

#define Rte_TypeDef_uint64
typedef unsigned long long    uint64;


typedef uint8 Std_ReturnType;
