/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: CruiseControl.c
 *
 * Code generated for Simulink model 'CruiseControl'.
 *
 * Model version                  : 5.2
 * Simulink Coder version         : 9.4 (R2020b) 29-Jul-2020
 * C/C++ source code generated on : Tue Jan 19 10:54:59 2021
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: 32-bit Generic
 * Emulation hardware selection:
 *    Differs from embedded hardware (MATLAB Host)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "CruiseControl.h"
#include "CruiseControl_private.h"

/* Named constants for Chart: '<S1>/Enable // Setpoint calculation' */
#define CruiseContro_IN_NO_ACTIVE_CHILD ((uint8_T)0U)
#define CruiseControl_IN_Decrement     ((uint8_T)1U)
#define CruiseControl_IN_Hold          ((uint8_T)2U)
#define CruiseControl_IN_Increment     ((uint8_T)3U)
#define CruiseControl_IN_Off           ((uint8_T)1U)
#define CruiseControl_IN_active        ((uint8_T)1U)
#define CruiseControl_IN_no_target     ((uint8_T)2U)
#define CruiseControl_IN_on            ((uint8_T)2U)
#define CruiseControl_IN_overide       ((uint8_T)3U)
#define CruiseControl_event_DEC_BD     (3)
#define CruiseControl_event_DEC_BU     (4)
#define CruiseControl_event_INC_BD     (1)
#define CruiseControl_event_INC_BU     (2)
#define CruiseControl_event_Resume     (6)
#define CruiseControl_event_Set        (5)
#define CruiseControl_event_Update     (0)

/* Block signals (default storage) */
B_CruiseControl_T CruiseControl_B;

/* Block states (default storage) */
DW_CruiseControl_T CruiseControl_DW;

/* Previous zero-crossings (trigger) states */
PrevZCX_CruiseControl_T CruiseControl_PrevZCX;

/* External inputs (root inport signals with default storage) */
/* AUTOSAR Overrides */
/* ExtU_CruiseControl_T CruiseControl_U;
*/

/* External outputs (root outports fed by signals with default storage) */
/* AUTOSAR Overrides */
ExtY_CruiseControl_T CruiseControl_Y;

/* Real-time model */
static RT_MODEL_CruiseControl_T CruiseControl_M_;
RT_MODEL_CruiseControl_T *const CruiseControl_M = &CruiseControl_M_;

/* Forward declaration for local functions */
static void Crui_chartstep_c1_CruiseControl(const int32_T *sfEvent);
static void rate_scheduler(void);

/*
 *   This function updates active task flag for each subrate.
 * The function is called at model base rate, hence the
 * generated code self-manages all its subrates.
 */
static void rate_scheduler(void)
{
  /* Compute which subrates run during the next base time step.  Subrates
   * are an integer multiple of the base rate counter.  Therefore, the subtask
   * counter is reset when it reaches its limit (zero means run).
   */
  (CruiseControl_M->Timing.TaskCounters.TID[1])++;
  if ((CruiseControl_M->Timing.TaskCounters.TID[1]) > 1) {/* Sample time: [1.0s, 0.0s] */
    CruiseControl_M->Timing.TaskCounters.TID[1] = 0;
  }
}

#if 1
#define INC_MPH(x)                                 \
    if (x < CC_TARGET_MPH_MAX) {                   \
        x += 1;                                    \
    } else {                                       \
        x = CC_TARGET_MPH_MAX;                     \
    }

#define DEC_MPH(x)                                 \
    if (x > CC_TARGET_MPH_MIN) {                   \
        x -= 1;                                    \
    } else {                                       \
        x = CC_TARGET_MPH_MIN;                     \
    }
#else
#define INC_MPH(x) x+=1
#define DEC_MPH(x) x-=1
#endif

/* Function for Chart: '<S1>/Enable // Setpoint calculation' */
static void Crui_chartstep_c1_CruiseControl(const int32_T *sfEvent)
{
  /* Chart: '<S1>/Enable // Setpoint calculation' incorporates:
   *  Inport: '<Root>/Power'
   *  Outport: '<Root>/Active'
   *  Outport: '<Root>/Target (MPH)'
   */
  if (CruiseControl_DW.is_active_c1_CruiseControl == 0U) {
    CruiseControl_DW.is_active_c1_CruiseControl = 1U;
    CruiseControl_DW.is_Set_Point_Calculation = CruiseControl_IN_Hold;
    CruiseControl_DW.is_Enable = CruiseControl_IN_Off;
  } else {
    switch (CruiseControl_DW.is_Set_Point_Calculation) {
     case CruiseControl_IN_Decrement:
      if (*sfEvent == CruiseControl_event_DEC_BU) {
        CruiseControl_DW.is_Set_Point_Calculation = CruiseControl_IN_Hold;
      } else {
        if ((*sfEvent == CruiseControl_event_Update) &&
            (CruiseControl_DW.temporalCounter_i1 == 1)) {
            DEC_MPH(CruiseControl_Y.TargetMPH);
            Rte_Write_TargetSpeed_TargetSpeed(CruiseControl_Y.TargetMPH);
        }
      }
      break;

     case CruiseControl_IN_Hold:
      if ((*sfEvent == CruiseControl_event_DEC_BD) && (CruiseControl_DW.is_on ==
           1)) {
        CruiseControl_DW.is_Set_Point_Calculation = CruiseControl_IN_Decrement;
        CruiseControl_DW.temporalCounter_i1 = 0U;
        DEC_MPH(CruiseControl_Y.TargetMPH);
        Rte_Write_TargetSpeed_TargetSpeed(CruiseControl_Y.TargetMPH);
      } else if ((*sfEvent == CruiseControl_event_INC_BD) &&
                 (CruiseControl_DW.is_on == 1)) {
        CruiseControl_DW.is_Set_Point_Calculation = CruiseControl_IN_Increment;
        CruiseControl_DW.temporalCounter_i1 = 0U;
        INC_MPH(CruiseControl_Y.TargetMPH);
        Rte_Write_TargetSpeed_TargetSpeed(CruiseControl_Y.TargetMPH);
      } else if ((*sfEvent == CruiseControl_event_Set) && Rte_DRead_Key_Key())
      {
        CruiseControl_Y.TargetMPH = 5.0;
        CruiseControl_DW.set_speed = 5.0;
		Rte_Write_TargetSpeed_TargetSpeed(CruiseControl_Y.TargetMPH);
      } else {
        if ((*sfEvent == CruiseControl_event_Resume) && Rte_DRead_Key_Key() &&
            (CruiseControl_DW.set_speed > 0.0)) {
          CruiseControl_Y.TargetMPH = CruiseControl_DW.set_speed;
		  Rte_Write_TargetSpeed_TargetSpeed(CruiseControl_Y.TargetMPH);
        }
      }
      break;

     default:
      /* case IN_Increment: */
      if (*sfEvent == CruiseControl_event_INC_BU) {
        CruiseControl_DW.is_Set_Point_Calculation = CruiseControl_IN_Hold;
      } else {
        if ((*sfEvent == CruiseControl_event_Update) &&
            (CruiseControl_DW.temporalCounter_i1 == 1)) {
            INC_MPH(CruiseControl_Y.TargetMPH);
            Rte_Write_TargetSpeed_TargetSpeed(CruiseControl_Y.TargetMPH);
        }
      }
      break;
    }

    if (CruiseControl_DW.is_Enable == CruiseControl_IN_Off) {
      if (Rte_DRead_Key_Key()) {
        CruiseControl_DW.is_Enable = CruiseControl_IN_on;
        CruiseControl_DW.is_on = CruiseControl_IN_no_target;
      }
    } else {
      /* case IN_on: */
      if (!Rte_DRead_Key_Key()) {
		Rte_Write_Active_Active(false);
/*        CruiseControl_Y.Active = false; */
        CruiseControl_DW.is_on = CruiseContro_IN_NO_ACTIVE_CHILD;
        CruiseControl_DW.is_Enable = CruiseControl_IN_Off;
      } else {
        switch (CruiseControl_DW.is_on) {
         case CruiseControl_IN_active:
          if (CruiseControl_B.DataTypeConversion) {
			Rte_Write_Active_Active(false);
/*            CruiseControl_Y.Active = false; */
            CruiseControl_DW.is_on = CruiseControl_IN_overide;
            CruiseControl_Y.TargetMPH = 0.0;
			Rte_Write_TargetSpeed_TargetSpeed(CruiseControl_Y.TargetMPH);
          }
          break;

         case CruiseControl_IN_no_target:
          if (*sfEvent == CruiseControl_event_Set) {
            CruiseControl_DW.is_on = CruiseControl_IN_active;
            CruiseControl_Y.Active = true;
			Rte_Write_Active_Active(true);
          }
          break;

         default:
          /* case IN_overide: */
          if ((*sfEvent == CruiseControl_event_Set) || (*sfEvent ==
               CruiseControl_event_Resume)) {
            CruiseControl_DW.is_on = CruiseControl_IN_active;
            CruiseControl_Y.Active = true;
			Rte_Write_Active_Active(true);
          }
          break;
        }
      }
    }
  }

  /* End of Chart: '<S1>/Enable // Setpoint calculation' */
}

/* Model step function */
FUNC(void, RTE_APPL_CODE) CruiseControl_step(void)
{
  int32_T rtb_PulseGenerator;
  int8_T rtb_inputevents[7];
  boolean_T zcEvent_0;
  ZCEventType zcEvent[7];

  /* DiscretePulseGenerator: '<S1>/Pulse Generator' */
  rtb_PulseGenerator = ((CruiseControl_DW.clockTickCounter < 1) &&
                        (CruiseControl_DW.clockTickCounter >= 0));
  if (CruiseControl_DW.clockTickCounter >= 1) {
    CruiseControl_DW.clockTickCounter = 0;
  } else {
    CruiseControl_DW.clockTickCounter++;
  }

  /* End of DiscretePulseGenerator: '<S1>/Pulse Generator' */
  if (CruiseControl_M->Timing.TaskCounters.TID[1] == 0) {
    /* DataTypeConversion: '<S1>/Data Type Conversion' incorporates:
     *  Inport: '<Root>/brake ratio'
     */
    CruiseControl_B.DataTypeConversion = (Rte_DRead_Brake_BrakePedalPosition() != 0);
  }

  /* Chart: '<S1>/Enable // Setpoint calculation' incorporates:
   *  TriggerPort: '<S2>/input events'
   */
  /* SignalConversion generated from: '<S2>/input events' */
  zcEvent[0] = rt_ZCFcn(ANY_ZERO_CROSSING,
                        &CruiseControl_PrevZCX.EnableSetpointcalculation_Trig_[0],
                        ((real_T)rtb_PulseGenerator));

  /* Inport: '<Root>/Increment' */
  zcEvent[1] = rt_ZCFcn(ANY_ZERO_CROSSING,
                        &CruiseControl_PrevZCX.EnableSetpointcalculation_Trig_[1],
                        (Rte_DRead_Commands_Increment()));
  zcEvent[2] = rt_ZCFcn(ANY_ZERO_CROSSING,
                        &CruiseControl_PrevZCX.EnableSetpointcalculation_Trig_[2],
                        (Rte_DRead_Commands_Increment()));

  /* Inport: '<Root>/Decrement' */
  zcEvent[3] = rt_ZCFcn(ANY_ZERO_CROSSING,
                        &CruiseControl_PrevZCX.EnableSetpointcalculation_Trig_[3],
                        (Rte_DRead_Commands_Decrement()));
  zcEvent[4] = rt_ZCFcn(ANY_ZERO_CROSSING,
                        &CruiseControl_PrevZCX.EnableSetpointcalculation_Trig_[4],
                        (Rte_DRead_Commands_Decrement()));

  /* Inport: '<Root>/Set' */
  zcEvent[5] = rt_ZCFcn(ANY_ZERO_CROSSING,
                        &CruiseControl_PrevZCX.EnableSetpointcalculation_Trig_[5],
                        (Rte_DRead_Commands_Set()));

  /* Inport: '<Root>/Resume' */
  zcEvent[6] = rt_ZCFcn(ANY_ZERO_CROSSING,
                        &CruiseControl_PrevZCX.EnableSetpointcalculation_Trig_[6],
                        (Rte_DRead_Commands_Resume()));
  zcEvent_0 = false;
  for (rtb_PulseGenerator = 0; rtb_PulseGenerator < 7; rtb_PulseGenerator++) {
    zcEvent_0 = (zcEvent_0 || (zcEvent[rtb_PulseGenerator] != NO_ZCEVENT));
  }

  if (zcEvent_0) {
    for (rtb_PulseGenerator = 0; rtb_PulseGenerator < 7; rtb_PulseGenerator++) {
      rtb_inputevents[rtb_PulseGenerator] = (int8_T)zcEvent[rtb_PulseGenerator];
    }

    if (rtb_inputevents[0U] == 1) {
      if (CruiseControl_DW.temporalCounter_i1 < 1U) {
        CruiseControl_DW.temporalCounter_i1++;
      }

      rtb_PulseGenerator = CruiseControl_event_Update;
      Crui_chartstep_c1_CruiseControl(&rtb_PulseGenerator);
      if (CruiseControl_DW.temporalCounter_i1 == 1U) {
        CruiseControl_DW.temporalCounter_i1 = 0U;
      }
    }

    if (rtb_inputevents[1U] == 1) {
      rtb_PulseGenerator = CruiseControl_event_INC_BD;
      Crui_chartstep_c1_CruiseControl(&rtb_PulseGenerator);
    }

    if (rtb_inputevents[2U] == -1) {
      rtb_PulseGenerator = CruiseControl_event_INC_BU;
      Crui_chartstep_c1_CruiseControl(&rtb_PulseGenerator);
    }

    if (rtb_inputevents[3U] == 1) {
      rtb_PulseGenerator = CruiseControl_event_DEC_BD;
      Crui_chartstep_c1_CruiseControl(&rtb_PulseGenerator);
    }

    if (rtb_inputevents[4U] == -1) {
      rtb_PulseGenerator = CruiseControl_event_DEC_BU;
      Crui_chartstep_c1_CruiseControl(&rtb_PulseGenerator);
    }

    if (rtb_inputevents[5U] != 0) {
      rtb_PulseGenerator = CruiseControl_event_Set;
      Crui_chartstep_c1_CruiseControl(&rtb_PulseGenerator);
    }

    if (rtb_inputevents[6U] != 0) {
      rtb_PulseGenerator = CruiseControl_event_Resume;
      Crui_chartstep_c1_CruiseControl(&rtb_PulseGenerator);
    }
  }

  rate_scheduler();
}

/* Model initialize function */
FUNC(void, RTE_APPL_CODE) CruiseControl_initialize(void)
{
  {
    int32_T i;
    for (i = 0; i < 7; i++) {
      CruiseControl_PrevZCX.EnableSetpointcalculation_Trig_[i] =
        UNINITIALIZED_ZCSIG;
    }
  }
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
