/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: CruiseControl.h
 *
 * Code generated for Simulink model 'CruiseControl'.
 *
 * Model version                  : 5.2
 * Simulink Coder version         : 9.4 (R2020b) 29-Jul-2020
 * C/C++ source code generated on : Tue Jan 19 10:54:59 2021
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: 32-bit Generic
 * Emulation hardware selection:
 *    Differs from embedded hardware (MATLAB Host)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_CruiseControl_h_
#define RTW_HEADER_CruiseControl_h_
#ifndef CruiseControl_COMMON_INCLUDES_
#define CruiseControl_COMMON_INCLUDES_
#include "rtwtypes.h"
#include "zero_crossing_types.h"
#endif                                 /* CruiseControl_COMMON_INCLUDES_ */

#include "CruiseControl_types.h"
#include "rt_zcfcn.h"

/* Added for verification with CPAChecker */
#include "AUTOSAR.h"

FUNC(void, RTE_APPL_CODE) CruiseControl_step(void);
FUNC(void, RTE_APPL_CODE) CruiseControl_initialize(void);

/* Limits to the speed range -- added 2022/04/12 */
#define CC_TARGET_MPH_MIN 1
#define CC_TARGET_MPH_MAX 20

/* Macros for accessing real-time model data structure */
#ifndef rtmGetErrorStatus
#define rtmGetErrorStatus(rtm)         ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
#define rtmSetErrorStatus(rtm, val)    ((rtm)->errorStatus = (val))
#endif

/* Block signals (default storage) */
typedef struct {
  boolean_T DataTypeConversion;        /* '<S1>/Data Type Conversion' */
} B_CruiseControl_T;

/* Block states (default storage) for system '<Root>' */
typedef struct {
  real_T set_speed;                  /* '<S1>/Enable // Setpoint calculation' */
  int32_T clockTickCounter;            /* '<S1>/Pulse Generator' */
  uint8_T is_active_c1_CruiseControl;/* '<S1>/Enable // Setpoint calculation' */
  uint8_T is_Set_Point_Calculation;  /* '<S1>/Enable // Setpoint calculation' */
  uint8_T is_Enable;                 /* '<S1>/Enable // Setpoint calculation' */
  uint8_T is_on;                     /* '<S1>/Enable // Setpoint calculation' */
  uint8_T temporalCounter_i1;        /* '<S1>/Enable // Setpoint calculation' */
} DW_CruiseControl_T;

/* Zero-crossing (trigger) state */
typedef struct {
  ZCSigState EnableSetpointcalculation_Trig_[7];
                                     /* '<S1>/Enable // Setpoint calculation' */
} PrevZCX_CruiseControl_T;

/* External inputs (root inport signals with default storage) */
typedef struct {
  real_T Increment;                    /* '<Root>/Increment' */
  real_T Decrement;                    /* '<Root>/Decrement' */
  real_T Set;                          /* '<Root>/Set' */
  real_T Resume;                       /* '<Root>/Resume' */
  boolean_T Power;                     /* '<Root>/Power' */
  real_T brakeratio;                   /* '<Root>/brake ratio' */
} ExtU_CruiseControl_T;

/* External outputs (root outports fed by signals with default storage) */
typedef struct {
  int32_T/*real_T*/ TargetMPH;                    /* '<Root>/Target (MPH)' */
  boolean_T Active;                    /* '<Root>/Active' */
} ExtY_CruiseControl_T;

/* Real-time Model Data Structure */
struct tag_RTM_CruiseControl_T {
  const char_T *errorStatus;

  /*
   * Timing:
   * The following substructure contains information regarding
   * the timing information for the model.
   */
  struct {
    struct {
      uint8_T TID[2];
    } TaskCounters;
  } Timing;
};

/* Block signals (default storage) */
extern B_CruiseControl_T CruiseControl_B;

/* Block states (default storage) */
extern DW_CruiseControl_T CruiseControl_DW;

/* Zero-crossing (trigger) state */
extern PrevZCX_CruiseControl_T CruiseControl_PrevZCX;

/* External inputs (root inport signals with default storage) */
/* AUTOSAR Overrides
extern ExtU_CruiseControl_T CruiseControl_U;
*/

/* External outputs (root outports fed by signals with default storage) */

extern ExtY_CruiseControl_T CruiseControl_Y;


/* Model entry point functions */
/* AUTOSAR Overrides
extern void CruiseControl_initialize(void);
extern void CruiseControl_step(void);
*/

/* Real-time Model object */
extern RT_MODEL_CruiseControl_T *const CruiseControl_M;

/*-
 * These blocks were eliminated from the model due to optimizations:
 *
 * Block '<S1>/Scope' : Unused code path elimination
 */

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Note that this particular code originates from a subsystem build,
 * and has its own system numbers different from the parent model.
 * Refer to the system hierarchy for this subsystem below, and use the
 * MATLAB hilite_system command to trace the generated code back
 * to the parent model.  For example,
 *
 * hilite_system('sf_cruise_control_coded/CruiseControlComponent/CruiseControl')    - opens subsystem sf_cruise_control_coded/CruiseControlComponent/CruiseControl
 * hilite_system('sf_cruise_control_coded/CruiseControlComponent/CruiseControl/Kp') - opens and selects block Kp
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'sf_cruise_control_coded/CruiseControlComponent'
 * '<S1>'   : 'sf_cruise_control_coded/CruiseControlComponent/CruiseControl'
 * '<S2>'   : 'sf_cruise_control_coded/CruiseControlComponent/CruiseControl/Enable // Setpoint calculation'
 */
#endif                                 /* RTW_HEADER_CruiseControl_h_ */

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
