
/**************************************************************************************
 * Copyright (c) Huawei Technologies Co., Ltd. 2019-2019. All rights reserved.
 * Description: Rte_BrakeActuator.c - The file has been not generated and validated in accordance with a safety standard
 * Author: VOS OS
 * Create: 2019-12-31
 *
 **************************************************************************************/

/***************************************************************************
 *
 * Includes
 *
 **************************************************************************/

/*
 * To restrict the SW-C APIs to a runnable use ONE of the following macros
 * #define RTE_RUNNABLEAPI_BA_Actuator
 * #define RTE_RUNNABLEAPI_BA_Watchdog
 */

/* Include application header file */
#include "Rte_BrakeActuator.h"
/* Version verification of the Rte_BrakeActuator module */
#if ((RTE_BRAKEACTUATOR_AR_RELEASE_MAJOR_VERSION != 4U) || (RTE_BRAKEACTUATOR_AR_RELEASE_MINOR_VERSION != 4U))
#error The imported RTE_BRAKEACTUATOR module version is incompatible, there may be problems.
#endif


// Start of user code for user-defined code

// End of user code
/********************************************************************************************************************
 * AtomicSwComponentType : BrakeActuator
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/
#define BRAKEACTUATOR_START_SEC_CODE
#include "BrakeActuator_MemMap.h"
/********************************************************************************************************************
 * Runnable Entity : RCBrakeActuation
 * ------------------------------------------------------------------------------------------------------------------
 *
 * =======================================
 *           Sender-Receiver
 * =======================================
 * @Function name : Rte_DRead_AEB_Brake_Brake
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_CC_Brake_Brake
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_CP_Brake_Brake
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_User_Brake_BrakePedalPosition
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_Write_BrakeAction_Brake
 * @Description   : Initiate an "explicit" sender-receiver transmission of data elements with "data" semantic
 *                  (swImplPolicy different from queued).
 * @Parameter     : VAR(float64, AUTOMATIC) value
 * @Return        : VAR(Std_ReturnType, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/

/********************************************************************************************************************
 * Start of Section for user's comment
 ********************************************************************************************************************/
// Start of user code : Add user comment for RCBrakeActuation
#define NB_INPUTS 4
// End of user code
/********************************************************************************************************************
 * End of Section for user's comment
 ********************************************************************************************************************/
FUNC(void, BrakeActuator_CODE) RCBrakeActuation (void)
{
    // Start of user code for the runnable of BA_Actuator
	/* local variables used in this function */
    float64 local_AEB_Brake;
    float64 local_CC_Brake;
    float64 local_User_Brake;
    float64 local_CP_Brake;
    float64 local_BrakeAction;
    
	float64 tmp [NB_INPUTS];
        int/*float64*/ index;

	/* Reading inputs */
    local_AEB_Brake = Rte_DRead_AEB_Brake_Brake ();
    local_CC_Brake = Rte_DRead_CC_Brake_Brake ();
    local_User_Brake = Rte_DRead_User_Brake_BrakePedalPosition ();
    local_CP_Brake = Rte_DRead_CP_Brake_Brake ();

    tmp [0] = local_AEB_Brake;
    tmp [1] = local_CC_Brake;
    tmp [2] = local_User_Brake;
    tmp [3] = local_CP_Brake;

    local_BrakeAction = 0;
    for (index = 0; index < NB_INPUTS; index++) {
        if(tmp[index] > local_BrakeAction) local_BrakeAction = tmp[index];
    }

    (void) Rte_Write_BrakeAction_Brake(local_BrakeAction);
   
    // End of user code
}
#define BRAKEACTUATOR_STOP_SEC_CODE
#include "BrakeActuator_MemMap.h"

#define BRAKEACTUATOR_START_SEC_CODE
#include "BrakeActuator_MemMap.h"
/********************************************************************************************************************
 * Runnable Entity : RCBrakeActuationWG
 * ------------------------------------------------------------------------------------------------------------------
 *
 * =======================================
 *           Sender-Receiver
 * =======================================
 * @Function name : Rte_DRead_AEB_Brake_Brake
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_BrakeAction_Brake
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_CC_Brake_Brake
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_CP_Brake_Brake
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_User_Brake_BrakePedalPosition
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_Write_BrakeAction_Brake
 * @Description   : Initiate an "explicit" sender-receiver transmission of data elements with "data" semantic
 *                  (swImplPolicy different from queued).
 * @Parameter     : VAR(float64, AUTOMATIC) value
 * @Return        : VAR(Std_ReturnType, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_Write_BrakeError_Error
 * @Description   : Initiate an "explicit" sender-receiver transmission of data elements with "data" semantic
 *                  (swImplPolicy different from queued).
 * @Parameter     : VAR(boolean, AUTOMATIC) value
 * @Return        : VAR(Std_ReturnType, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/

/********************************************************************************************************************
 * Start of Section for user's comment
 ********************************************************************************************************************/
// Start of user code : Add user comment for RCBrakeActuationWG

// End of user code
/********************************************************************************************************************
 * End of Section for user's comment
 ********************************************************************************************************************/
FUNC(void, BrakeActuator_CODE) RCBrakeActuationWG (void)
{
    // Start of user code for the runnable of BA_Watchdog
    float64 local_AEB_Brake;
    float64 local_CC_Brake;
    float64 local_User_Brake;
    float64 local_CP_Brake;
    float64 local_BrakeAction = 0;
    
	/* Reading inputs */
    local_AEB_Brake = Rte_DRead_AEB_Brake_Brake ();
    local_CC_Brake = Rte_DRead_CC_Brake_Brake();
    local_User_Brake = Rte_DRead_User_Brake_BrakePedalPosition ();
    local_CP_Brake = Rte_DRead_CP_Brake_Brake ();

    /* Watch Brake Action */
    if ((Rte_DRead_BrakeAction_Brake() > local_AEB_Brake) &&
			(Rte_DRead_BrakeAction_Brake() > local_CC_Brake) &&
			(Rte_DRead_BrakeAction_Brake() > local_User_Brake) &&
			(Rte_DRead_BrakeAction_Brake() > local_CP_Brake))  {
        (void)Rte_Write_BrakeError_Error (TRUE);
        (void)Rte_Write_BrakeAction_Brake(local_BrakeAction);
    }
    else {
        (void)Rte_Write_BrakeError_Error (FALSE);
    }

    // End of user code
}
#define BRAKEACTUATOR_STOP_SEC_CODE
#include "BrakeActuator_MemMap.h"
