
/**************************************************************************************
 * Copyright (c) Huawei Technologies Co., Ltd. 2019-2019. All rights reserved.
 * Description: Rte_BrakeCommand.c - The file has been not generated and validated in accordance with a safety standard
 * Author: VOS OS
 * Create: 2019-12-31
 *
 **************************************************************************************/

/***************************************************************************
 *
 * Includes
 *
 **************************************************************************/

/*
 * To restrict the SW-C APIs to a runnable use ONE of the following macros
 * #define RTE_RUNNABLEAPI_RBrakeCommand
 */

/* Include application header file */
#include "Rte_BrakeCommand.h"
/* Version verification of the Rte_BrakeCommand module */
#if ((RTE_BRAKECOMMAND_AR_RELEASE_MAJOR_VERSION != 4U) || (RTE_BRAKECOMMAND_AR_RELEASE_MINOR_VERSION != 4U))
#error The imported RTE_BRAKECOMMAND module version is incompatible, there may be problems.
#endif


// Start of user code for user-defined code

// End of user code
/********************************************************************************************************************
 * AtomicSwComponentType : BrakeCommand
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/
#define BRAKECOMMAND_START_SEC_CODE
#include "BrakeCommand_MemMap.h"
/********************************************************************************************************************
 * Runnable Entity : RBrakeCommand
 * ------------------------------------------------------------------------------------------------------------------
 *
 * =======================================
 *           Sender-Receiver
 * =======================================
 * @Function name : Rte_DRead_BrakeSensor1_BrakePedalPosition
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_BrakeSensor2_BrakePedalPosition
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_BrakeSensor1_IsDataValid
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(boolean, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_BrakeSensor2_IsDataValid
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(boolean, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_Write_Brake_BrakePedalPosition
 * @Description   : Initiate an "explicit" sender-receiver transmission of data elements with "data" semantic
 *                  (swImplPolicy different from queued).
 * @Parameter     : VAR(float64, AUTOMATIC) value
 * @Return        : VAR(Std_ReturnType, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_Write_Brake_IsDataValid
 * @Description   : Initiate an "explicit" sender-receiver transmission of data elements with "data" semantic
 *                  (swImplPolicy different from queued).
 * @Parameter     : VAR(boolean, AUTOMATIC) value
 * @Return        : VAR(Std_ReturnType, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/

/********************************************************************************************************************
 * Start of Section for user's comment
 ********************************************************************************************************************/
// Start of user code : Add user comment for RBrakeCommand

// End of user code
/********************************************************************************************************************
 * End of Section for user's comment
 ********************************************************************************************************************/
FUNC(void, BrakeCommand_CODE) RBrakeCommand (void)
{
    // Start of user code for the runnable of RBrakeCommand
    
    boolean local_IsBrakeSensorValid;
    boolean local_IsBrakeSensorValid_1;
    boolean local_IsBrakeSensorValid_2;
    float64 local_BrakePedalPosition;
    float64 local_BrakePedalPosition_1;
    float64 local_BrakePedalPosition_2;

    local_IsBrakeSensorValid_1 = Rte_DRead_BrakeSensor1_IsDataValid();
    local_BrakePedalPosition_1 = Rte_DRead_BrakeSensor1_BrakePedalPosition();
    local_IsBrakeSensorValid_2 = Rte_DRead_BrakeSensor2_IsDataValid();
    local_BrakePedalPosition_2 = Rte_DRead_BrakeSensor2_BrakePedalPosition();

    local_IsBrakeSensorValid = FALSE;
    local_BrakePedalPosition = 0;

    if (local_IsBrakeSensorValid_1) {
        local_IsBrakeSensorValid = TRUE;
        local_BrakePedalPosition = local_BrakePedalPosition_1;
    }
    if (local_IsBrakeSensorValid_2) {
        local_IsBrakeSensorValid = TRUE;
        if (local_BrakePedalPosition_2 > local_BrakePedalPosition) {
            local_BrakePedalPosition = local_BrakePedalPosition_2;
        }
    }

    Rte_Write_Brake_IsDataValid(local_IsBrakeSensorValid);
    Rte_Write_Brake_BrakePedalPosition(local_BrakePedalPosition);

    // End of user code
}
#define BRAKECOMMAND_STOP_SEC_CODE
#include "BrakeCommand_MemMap.h"
