
/**************************************************************************************
 * Copyright (c) Huawei Technologies Co., Ltd. 2019-2019. All rights reserved.
 * Description: Rte_CrashPreparation.c - The file has been not generated and validated in accordance with a safety standard
 * Author: VOS OS
 * Create: 2019-12-31
 *
 **************************************************************************************/

/***************************************************************************
 *
 * Includes
 *
 **************************************************************************/

/*
 * To restrict the SW-C APIs to a runnable use ONE of the following macros
 * #define RTE_RUNNABLEAPI_RCrashPreparation
 */

/* Include application header file */
#include "Rte_CrashPreparation.h"
/* Version verification of the Rte_CrashPreparation module */
#if ((RTE_CRASHPREPARATION_AR_RELEASE_MAJOR_VERSION != 4U) || (RTE_CRASHPREPARATION_AR_RELEASE_MINOR_VERSION != 4U))
#error The imported RTE_CRASHPREPARATION module version is incompatible, there may be problems.
#endif


// Start of user code for user-defined code

// End of user code
/********************************************************************************************************************
 * AtomicSwComponentType : CrashPreparation
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/
/********************************************************************************************************************
 * Runnable Entity : RCrashPrepLogic
 * ------------------------------------------------------------------------------------------------------------------
 *
 * =======================================
 *           Sender-Receiver
 * =======================================
 * @Function name : Rte_DRead_RelativeDistance_RelativeDistance
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_RelativeSpeed_RelativeSpeed
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_VehicleSpeed_VehicleSpeed
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(float64, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_Write_Brake_Brake
 * @Description   : Initiate an "explicit" sender-receiver transmission of data elements with "data" semantic
 *                  (swImplPolicy different from queued).
 * @Parameter     : VAR(float64, AUTOMATIC) value
 * @Return        : VAR(Std_ReturnType, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_Write_SeatBelt_Tension
 * @Description   : Initiate an "explicit" sender-receiver transmission of data elements with "data" semantic
 *                  (swImplPolicy different from queued).
 * @Parameter     : VAR(boolean, AUTOMATIC) value
 * @Return        : VAR(Std_ReturnType, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/

/********************************************************************************************************************
 * Start of Section for user's comment
 ********************************************************************************************************************/
// Start of user code : Add user comment for RCrashPrepLogic
#define FULL_BRAKE 9.6
// End of user code
/********************************************************************************************************************
 * End of Section for user's comment
 ********************************************************************************************************************/
FUNC(void, CrashPreparation_CODE) RCrashPrepLogic (void)
{
    // Start of user code for the runnable of RCrashPrepLogic
    float64 t_stop = ((Rte_DRead_VehicleSpeed_VehicleSpeed ()) / 3.6)/(FULL_BRAKE);

    float64 rel_dist = Rte_DRead_RelativeDistance_RelativeDistance ();
    float64 rel_speed = Rte_DRead_RelativeSpeed_RelativeSpeed ();
    float32 ttc = 0;

    uint8 sb = 0;
    float64 brake = 0;

    if (rel_speed  < 0) {

        ttc = rel_dist / (-rel_speed);

        if (t_stop >= ttc) {
            sb = 255;
            brake = FULL_BRAKE;
        }
    }
    else
    {
        sb = 0;
        brake = 0;
    }

    Rte_Write_SeatBelt_Tension(sb);
    Rte_Write_Brake_Brake(brake);
    // End of user code

}
