
/**************************************************************************************
 * Copyright (c) Huawei Technologies Co., Ltd. 2019-2019. All rights reserved.
 * Description: Rte_ThrottleActuator.c - The file has been not generated and validated in accordance with a safety standard
 * Author: VOS OS
 * Create: 2019-12-31
 *
 **************************************************************************************/

/***************************************************************************
 *
 * Includes
 *
 **************************************************************************/

/*
 * To restrict the SW-C APIs to a runnable use ONE of the following macros
 * #define RTE_RUNNABLEAPI_RThrottleActuator
 */

/* Include application header file */
#include "Rte_ThrottleActuator.h"
/* Version verification of the Rte_ThrottleActuator module */
#if ((RTE_THROTTLEACTUATOR_AR_RELEASE_MAJOR_VERSION != 4U) || (RTE_THROTTLEACTUATOR_AR_RELEASE_MINOR_VERSION != 4U))
#error The imported RTE_THROTTLEACTUATOR module version is incompatible, there may be problems.
#endif


// Start of user code for user-defined code

// End of user code
/********************************************************************************************************************
 * AtomicSwComponentType : ThrottleActuator
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/
#define THROTTLEACTUATOR_START_SEC_CODE
#include "ThrottleActuator_MemMap.h"
/********************************************************************************************************************
 * Runnable Entity : RThrottleActuator
 * ------------------------------------------------------------------------------------------------------------------
 *
 * =======================================
 *           Sender-Receiver
 * =======================================
 * @Function name : Rte_DRead_CC_Throttle_Throttle
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(uint8, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_User_Throttle_IsDataValid
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(uint8, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_User_Throttle_ThrottlePedalPosition
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(uint8, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_Write_ThrottleAction_Throttle
 * @Description   : Initiate an "explicit" sender-receiver transmission of data elements with "data" semantic
 *                  (swImplPolicy different from queued).
 * @Parameter     : VAR(uint8, AUTOMATIC) value
 * @Return        : VAR(Std_ReturnType, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/

/********************************************************************************************************************
 * Start of Section for user's comment
 ********************************************************************************************************************/
// Start of user code : Add user comment for RThrottleActuator

// End of user code
/********************************************************************************************************************
 * End of Section for user's comment
 ********************************************************************************************************************/
FUNC(void, ThrottleActuator_CODE) RThrottleActuator (void)
{
    // Start of user code for the runnable of RThrottleActuator

    boolean local_IsUserThrottleValid;
    uint8 local_User_Throttle;
    uint8 local_CC_Throttle;
    uint8 local_Throttle;

    local_IsUserThrottleValid = Rte_DRead_User_Throttle_IsDataValid();
    local_User_Throttle = Rte_DRead_User_Throttle_ThrottlePedalPosition();
    local_CC_Throttle = Rte_DRead_CC_Throttle_Throttle();

    local_Throttle = local_CC_Throttle;

    if (local_IsUserThrottleValid && local_User_Throttle > 0) {
        local_Throttle = local_User_Throttle;
    }

    Rte_Write_ThrottleAction_Throttle(local_Throttle);

    // End of user code
}
#define THROTTLEACTUATOR_STOP_SEC_CODE
#include "ThrottleActuator_MemMap.h"
