
/**************************************************************************************
 * Copyright (c) Huawei Technologies Co., Ltd. 2019-2019. All rights reserved.
 * Description: Rte_ThrottleCommand.c - The file has been not generated and validated in accordance with a safety standard
 * Author: VOS OS
 * Create: 2019-12-31
 *
 **************************************************************************************/

/***************************************************************************
 *
 * Includes
 *
 **************************************************************************/

/*
 * To restrict the SW-C APIs to a runnable use ONE of the following macros
 * #define RTE_RUNNABLEAPI_ThrottleCommand_Step
 */

/* Include application header file */
#include "Rte_ThrottleCommand.h"
/* Version verification of the Rte_ThrottleCommand module */
#if ((RTE_THROTTLECOMMAND_AR_RELEASE_MAJOR_VERSION != 4U) || (RTE_THROTTLECOMMAND_AR_RELEASE_MINOR_VERSION != 4U))
#error The imported RTE_THROTTLECOMMAND module version is incompatible, there may be problems.
#endif


// Start of user code for user-defined code

// End of user code
/********************************************************************************************************************
 * AtomicSwComponentType : ThrottleCommand
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/
#define THROTTLECOMMAND_START_SEC_CODE
#include "ThrottleCommand_MemMap.h"
/********************************************************************************************************************
 * Runnable Entity : RThrottleCommand
 * ------------------------------------------------------------------------------------------------------------------
 *
 * =======================================
 *           Sender-Receiver
 * =======================================
 * @Function name : Rte_DRead_ThrottleSensor1_IsDataValid
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(boolean, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_ThrottleSensor2_IsDataValid
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(boolean, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_ThrottleSensor1_ThrottlePedalPosition
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(uint8, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_DRead_ThrottleSensor2_ThrottlePedalPosition
 * @Description   : Performs an "explicit" read on a sender-receiver communication data element with "data" semantics
 *                  (swImplPolicy != queued). By compatibility, the port may also have a ParameterInterface or a
 *                  NvDataInterface. The Rte_DRead API is used for explicit read by value.
 * @Parameter     : None
 * @Return        : VAR(uint8, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_Write_ThrottleCommand_IsDataValid
 * @Description   : Initiate an "explicit" sender-receiver transmission of data elements with "data" semantic
 *                  (swImplPolicy different from queued).
 * @Parameter     : VAR(boolean, AUTOMATIC) value
 * @Return        : VAR(Std_ReturnType, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 * @Function name : Rte_Write_ThrottleCommand_ThrottlePedalPosition
 * @Description   : Initiate an "explicit" sender-receiver transmission of data elements with "data" semantic
 *                  (swImplPolicy different from queued).
 * @Parameter     : VAR(uint8, AUTOMATIC) value
 * @Return        : VAR(Std_ReturnType, AUTOMATIC)
 * ------------------------------------------------------------------------------------------------------------------
 *
 *******************************************************************************************************************/

/********************************************************************************************************************
 * Start of Section for user's comment
 ********************************************************************************************************************/
// Start of user code : Add user comment for RThrottleCommand

// End of user code
/********************************************************************************************************************
 * End of Section for user's comment
 ********************************************************************************************************************/
FUNC(void, ThrottleCommand_CODE) RThrottleCommand (void)
{
    // Start of user code for the runnable of ThrottleCommand_Step

    boolean local_IsThrottleSensorValid;
    boolean local_IsThrottleSensorValid_1;
    boolean local_IsThrottleSensorValid_2;
    uint8 local_ThrottlePedalPosition;
    uint8 local_ThrottlePedalPosition_1;
    uint8 local_ThrottlePedalPosition_2;

    local_IsThrottleSensorValid_1 = Rte_DRead_ThrottleSensor1_IsDataValid();
    local_ThrottlePedalPosition_1 = Rte_DRead_ThrottleSensor1_ThrottlePedalPosition();
    local_IsThrottleSensorValid_2 = Rte_DRead_ThrottleSensor2_IsDataValid();
    local_ThrottlePedalPosition_2 = Rte_DRead_ThrottleSensor2_ThrottlePedalPosition();

    local_IsThrottleSensorValid = FALSE;
    local_ThrottlePedalPosition = 0;

    if (local_IsThrottleSensorValid_1 > 0) {
        local_IsThrottleSensorValid = TRUE;
        local_ThrottlePedalPosition = local_ThrottlePedalPosition_1;
    }
    if (local_IsThrottleSensorValid_2 > 0) {
        local_IsThrottleSensorValid = TRUE;
        if (local_ThrottlePedalPosition_2 > local_ThrottlePedalPosition) {
            local_ThrottlePedalPosition = local_ThrottlePedalPosition_2;
        }
    }

    Rte_Write_ThrottleCommand_IsDataValid(local_IsThrottleSensorValid);
    Rte_Write_ThrottleCommand_ThrottlePedalPosition(local_ThrottlePedalPosition);

    // End of user code
}
#define THROTTLECOMMAND_STOP_SEC_CODE
#include "ThrottleCommand_MemMap.h"
